<!DOCTYPE html>
<html>
    <head>
        <meta charset="utf-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
        <title>March 2010 Progress Report</title>
        <meta name="viewport" content="width=device-width">

        <!-- syntax highlighting CSS -->
        <link rel="stylesheet" href="/css/syntax.css">

        <!-- Custom CSS -->
        <link rel="stylesheet" href="/css/main.css">

    </head>
    <body>

        <div class="site">
          <div class="header">
            <h1 class="title"><a href="/">Your New Jekyll Site</a></h1>
            <a class="extra" href="/">home</a>
          </div>

          <h2>March 2010 Progress Report</h2>
<p class="meta">18 Apr 2010</p>

<div class="post">
<p><strong>New Releases</strong><br>
On March 7th, we released the latest in the -alpha series, Tor 0.2.2.10-alpha. Tor 0.2.2.10-alpha fixes a regression introduced in 0.2.2.9-alpha that could prevent relays from guessing their IP address correctly. It also starts the groundwork for another client-side performance boost, since currently we&#39;re not making efficient use of relays that have both the Guard flag and the Exit flag.</p>

<p>o Major bugfixes:<br>
 - Fix a regression from our patch for bug 1244 that caused relays<br>
 to guess their IP address incorrectly if they didn&#39;t set Address<br>
 in their torrc and/or their address fails to resolve. Bugfix on<br>
 0.2.2.9-alpha; fixes bug 1269.</p>

<p>o Major features (performance):<br>
 - Directory authorities now compute consensus weightings that instruct<br>
 clients how to weight relays flagged as Guard, Exit, Guard+Exit,<br>
 and no flag. Clients that use these weightings will distribute<br>
 network load more evenly across these different relay types. The<br>
 weightings are in the consensus so we can change them globally in<br>
 the future. Extra thanks to &quot;outofwords&quot; for finding some nasty<br>
 security bugs in the first implementation of this feature.</p>

<p>o Minor features (performance):<br>
 - Always perform router selections using weighted relay bandwidth,<br>
 even if we don&#39;t need a high capacity circuit at the time. Non-fast<br>
 circuits now only differ from fast ones in that they can use relays<br>
 not marked with the Fast flag. This &quot;feature&quot; could turn out to<br>
 be a horrible bug; we should investigate more before it goes into<br>
 a stable release.</p>

<p>o Minor features:<br>
 - Allow disabling building of the manpages. Skipping the manpage<br>
 speeds up the build considerably.</p>

<p>o Minor bugfixes (on 0.2.2.x):<br>
 - Fix a memleak in the EXTENDCIRCUIT logic. Spotted by coverity.<br>
 Bugfix on 0.2.2.9-alpha.<br>
 - Disallow values larger than INT32_MAX for PerConnBWRate|Burst<br>
 config option. Bugfix on 0.2.2.7-alpha.<br>
 - Ship the asciidoc-helper file in the tarball, so that people can<br>
 build from source if they want to, and touching the .1.txt files<br>
 doesn&#39;t break the build. Bugfix on 0.2.2.9-alpha.</p>

<p>o Minor bugfixes (on 0.2.1.x or earlier):<br>
 - Fix a dereference-then-NULL-check sequence when publishing<br>
 descriptors. Bugfix on 0.2.1.5-alpha. Discovered by ekir; fixes<br>
 bug 1255.<br>
 - Fix another dereference-then-NULL-check sequence. Bugfix on<br>
 0.2.1.14-rc. Discovered by ekir; fixes bug 1256.<br>
 - Make sure we treat potentially not NUL-terminated strings correctly.<br>
 Bugfix on 0.1.1.13-alpha. Discovered by rieo; fixes bug 1257.</p>

<p>o Code simplifications and refactoring:<br>
 - Fix some urls in the exit notice file and make it XHTML1.1 strict<br>
 compliant. Based on a patch from Christian Kujau.<br>
 - Don&#39;t use sed in asciidoc-helper anymore.<br>
 - Make the build process fail if asciidoc cannot be found and<br>
 building with asciidoc isn&#39;t disabled.</p>

<p>On March 15, we released the latest in the -stable series, Tor 0.2.1.25-stable.</p>

<p>o Major bugfixes:<br>
 - Fix a regression from our patch for bug 1244 that caused relays<br>
 to guess their IP address incorrectly if they didn&#39;t set Address<br>
 in their torrc and/or their address fails to resolve. Bugfix on<br>
 0.2.1.23; fixes bug 1269.<br>
 - When freeing a session key, zero it out completely. We only zeroed<br>
 the first ptrsize bytes. Bugfix on 0.0.2pre8. Discovered and<br>
 patched by ekir. Fixes bug 1254.</p>

<p>o Minor bugfixes:<br>
 - Fix a dereference-then-NULL-check sequence when publishing<br>
 descriptors. Bugfix on 0.2.1.5-alpha. Discovered by ekir; fixes<br>
 bug 1255.<br>
 - Fix another dereference-then-NULL-check sequence. Bugfix on<br>
 0.2.1.14-rc. Discovered by ekir; fixes bug 1256.<br>
 - Make sure we treat potentially not NUL-terminated strings correctly.<br>
 Bugfix on 0.1.1.13-alpha. Discovered by rieo; fixes bug 1257.</p>

<p>On March 26 we released the first beta of a Tor Browser Bundle for GNU/Linux operating systems. It is now available for x86 and x86_64 architectures in 12 languages.</p>

<p>The bundle comes with the following software:<br>
 * Tor 0.2.2.10-alpha<br>
 * Vidalia 0.2.7 -- cross-platform controller GUI for the Tor software<br>
 * Polipo 1.0.4.1 -- caching web proxy<br>
 * Firefox 3.5.8 -- web browser<br>
 * Torbutton 1.2.4 -- Firefox extension to enable or disable the browser&#39;s use of Tor<br>
 * NoScript 1.9.9.57 -- Firefox extension to only allow scripts from trusted sites<br>
 * BetterPrivacy 1.4.7 -- Firefox extension to protect against supercookies</p>

<p>Orbot 0.0.4 is the first public release. Orbot includes:</p>

<p>* Tor 0.2.2.9-alpha<br>
* A native Android control graphical interface<br>
* Privoxy compiled for Android</p>

<p>March 11 we released Orbot 0.0.5 for Android phones. It fixes a number of bugs in the graphical control interface and updated Tor to 0.2.2.10-alpha.</p>

<p><strong>Design, develop, and implement enhancements that make Tor a better tool for users in censored countries.</strong></p>

<p>We worked with activists in Iran and China to determine what relays were blocked, if any, by national firewall apparatus. Iran is not blocking Tor relays at all. China is blocking most public relays, and appears to have crawled the bridge address website in order to block those bridges. There were 4121 requests in a 6 hour period from seemingly unique gmail accounts for bridge addresses via email. However, we cannot attribute this to anything other than users requesting bridges. It is possible this was an attempt to enumerate all bridges available via email. Our twitter and qq distribution methods remain under utilized.</p>

<p>Implemented graphs of packages served by our get-tor email autoresponder. You can see them at <a href="http://metrics.torproject.org/gettor-graphs.html" title="http://metrics.torproject.org/gettor-graphs.html">http://metrics.torproject.org/gettor-graphs.html</a></p>

<p><strong>Outreach and Advocacy</strong></p>

<ul>
<li>On March 1, Roger met with Sina from Access. He answered many questions about Tor, learned more about the situation in Iran now, and helped brainstorm about further collaborations.</li>
<li>On March 2, Karen was a panelist at the University of Maryland Digital Media Conference. </li>
<li>On March 12, Jacob spoke at Digital Security and Tactics for (and by) anti-authoritarians. https://www.noisebridge.net/wiki/Digital_Security_and_Tactics_For_(and_By)_Anti_Authoritarians</li>
<li>On March 20, Andrew, Erinn, and Runa attended LibrePlanet 2010. Erinn was a panelist at a session about &quot;Women in Technology and Free Software&quot;. Andrew spoke about Tor, Free Software, and running a non-profit business with free software. <a href="http://libreplanet.org/2010" title="http://libreplanet.org/2010">http://libreplanet.org/2010</a></li>
<li>A Tor fan created a very quick advocacy video about using Tor for circumvention at <a href="http://media.torproject.org/video/TorQatarCensor15secs2b.ogv" title="http://media.torproject.org/video/TorQatarCensor15secs2b.ogv">http://media.torproject.org/video/TorQatarCensor15secs2b.ogv</a>.</li>
<li>Andrew was interviewed by ABC Australia&#39;s Future Tense program about the &quot;DarkWeb&quot;. You can listen to the radio interview at <a href="http://media.torproject.org/video/2010-03-11-ABC-Australia-FutureTense-Interview.mp3" title="http://media.torproject.org/video/2010-03-11-ABC-Australia-FutureTense-Interview.mp3">http://media.torproject.org/video/2010-03-11-ABC-Australia-FutureTense-I...</a> or read the transcript at <a href="http://www.abc.net.au/rn/futuretense/stories/2010/2837736.htm" title="http://www.abc.net.au/rn/futuretense/stories/2010/2837736.htm">http://www.abc.net.au/rn/futuretense/stories/2010/2837736.htm</a>.</li>
<li>Steven Murdoch was interviewed by PC Pro UK magazine about &quot;The Dark Side of the Web&quot;, <a href="http://www.pcpro.co.uk/features/356254/the-dark-side-of-the-web" title="http://www.pcpro.co.uk/features/356254/the-dark-side-of-the-web">http://www.pcpro.co.uk/features/356254/the-dark-side-of-the-web</a>.</li>
<li>On March 25, we announced The Tor Store to allow users to support Tor from around the world with t-shirts, mugs, and other merchandise. <a href="https://www.torproject.org/press/2010-03-25-tor-store-press-release.html.en" title="https://www.torproject.org/press/2010-03-25-tor-store-press-release.html.en">https://www.torproject.org/press/2010-03-25-tor-store-press-release.html...</a>.</li>
<li>Tor and EFF were accepted into the Google Summer of Code for the fourth year in a row. <a href="https://blog.torproject.org/blog/tor-google-summer-code-2010" title="https://blog.torproject.org/blog/tor-google-summer-code-2010">https://blog.torproject.org/blog/tor-google-summer-code-2010</a>.</li>
<li>Jacob gave a Tor talk to Twitter engineers about circumvention, anonymity, and the positive uses of both technologies.</li>
<li>Erinn, Jacob, and Mike talked to Google engineers about Tor on Android and better integration with the Chrome browser.</li>
<li>Christian rewrote the Tor Weather web application, <a href="https://weather.torproject.org/" title="https://weather.torproject.org/">https://weather.torproject.org/</a>, to increase stability, fix a number of bugs, and add some requested features. Tor Weather is a tool for relay operators to get a reminder when their relay appears to be offline.</li>
</ul>

<p><strong>Preconfigured privacy (circumvention) bundles for USB or LiveCD.</strong><br>
A beta-test of Tor Browser Bundle for GNU/Linux was released for general testing. It is released in both native 32-bit and 64-bit versions. See release notes above.</p>

<p><strong>Bridge relay and bridge authority work.</strong><br>
Steven started work on a proposal to turn all clients into bridges by default. This proposal describes how Tor clients could determine when they have sufficient bandwidth capacity and are sufficiently reliable to become either bridges or Tor relays. When they meet this criteria, they will automatically promote themselves, based on user preferences. The proposal also defines the new controller messages and options which will control this process.</p>

<p>Note that for the moment, only transitions between client and bridge are being considered. Transitions to public relay will be considered at a future date, but will use the same infrastructure for measuring capacity and reliability.</p>

<p>The full proposal, and subsequent discussion, can be read at <a href="http://archives.seul.org/or/dev/Mar-2010/msg00028.html" title="http://archives.seul.org/or/dev/Mar-2010/msg00028.html">http://archives.seul.org/or/dev/Mar-2010/msg00028.html</a>.</p>

<p><strong>Scalability, load balancing, directory overhead, efficiency.</strong><br>
Karsten continued to improve the Tor Metrics Portal, <a href="http://metrics.torproject.org/" title="http://metrics.torproject.org/">http://metrics.torproject.org/</a>. More reports were automated. The entire setup and process of how we analyze the data was documented. We could use volunteer help with portal and data visualization technologies and implementation experience.</p>

<p>We added proposal 170, &quot;Configuration options regarding circuit building&quot;. Tor&#39;s treatment of the various configuration *Nodes options was surprising to many users, and quite a few conspiracy theories have crept up. We should update our specification and code to better describe and to communicate what is going during circuit building, and how we&#39;re honoring configuration. So far, we&#39;ve been tracking a bugreport about this behaviour ( <a href="https://bugs.torproject.org/flyspray/index.php?do=details&amp;id=1090" title="https://bugs.torproject.org/flyspray/index.php?do=details&amp;id=1090">https://bugs.torproject.org/flyspray/index.php?do=details&amp;id=1090</a>) and Nick replied in a thread on or-talk ( <a href="http://archives.seul.org/or/talk/Feb-2010/msg00117.html" title="http://archives.seul.org/or/talk/Feb-2010/msg00117.html">http://archives.seul.org/or/talk/Feb-2010/msg00117.html</a>). This proposal tries to document our intention for those configuration options.</p>

<p><strong>Translation work, ultimately a browser-based approach.</strong></p>

<ul>
<li>Language updates to the website in French, Chinese, German, Spanish, Polish, Russian, Estonian, Norwegian, Greek</li>
<li>Language updates to the get-tor email autoresponder in Vietnamese, Dutch,</li>
<li>Language updates to torbutton in Arabic, German, Danish, Slovakian, Swedish, Vietnamese, Russian</li>
<li>Runa fixed a large amount of broken html and translated files. This enabled us to push nearly all projects and languages into the codebases. </li>
</ul>

</div>
<p>- phobos</p>


          <div class="footer">
            <div class="contact">
              <p>
                Your Name<br />
                What You Are<br />
                you@example.com
              </p>
            </div>
            <div class="contact">
              <p>
                <a href="https://github.com/yourusername">github.com/yourusername</a><br />
                <a href="https://twitter.com/yourusername">twitter.com/yourusername</a><br />
              </p>
            </div>
          </div>
        </div>

    </body>
</html>
